import pygtk
pygtk.require("2.0")
import gtk
import gobject
import os
from os import sep
import sys
import getopt
import clientStuff
import nevral
import pkgaction
import callback
import time
import random
import locale
import rpm
import rpmUtils
import yumcomps
import time
import commands
from cStringIO import StringIO
from logger import Logger
from config import yumconf
from i18n import _
from threading import Thread
import progress_bar
#import FileStream

__version__='2.0.7'
product_name='Cobind Software Manager'
product_image_file='yumi.png'
product_icon_file='/usr/share/pixmaps/default-applications-capplet.png'
view = None
choose_parent_view = None
dialog = None
#nautilus_desktop=commands.getoutput("echo $HOME")
nautilus_desktop=None

class textviewStream:
	def __init__(self,textview, statusbar=None):
		self.textview = textview
		self.statusbar = statusbar
	def write(self, s):	
    		self.textview.get_buffer().insert_at_cursor(s)
		self.textview.scroll_to_iter(self.textview.get_buffer().get_end_iter(), 0.0)
		if self.statusbar:
			self.statusbar.push(1,s)
		repaint()
		print s
	def set_textview(self,textview):
		self.textview = textview

# util functions.  This needs to pulled out into a seperate class
def createScrollText(labelText):
    label = gtk.Label(labelText)
    label.set_justify(gtk.JUSTIFY_LEFT)
    label.set_alignment(0,0)
    textview = gtk.TextView(buffer=None)
    textview.set_wrap_mode(gtk.WRAP_WORD)
    textview.set_editable(gtk.FALSE)
    textview.set_sensitive(gtk.FALSE)
    output = textview.get_buffer()
    scrolled = gtk.ScrolledWindow()
    scrolled.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    scrolled.add(textview)
    vbox = gtk.VBox(spacing=2)
    vbox.pack_start(label, expand=gtk.FALSE, fill=gtk.FALSE)
    vbox.pack_start(scrolled, expand=gtk.TRUE, fill=gtk.TRUE)
    vbox.show_all()
    return (vbox, label, output)

def createTextBox(labelText):
    label = gtk.Label(labelText)
    entry = gtk.Entry()
    entry.set_editable(gtk.FALSE)
    entry.set_sensitive(gtk.FALSE)
    hbox = gtk.HBox(spacing=2)
    hbox.pack_start(label, expand=gtk.FALSE, fill=gtk.FALSE)
    hbox.pack_start(entry, expand=gtk.TRUE, fill=gtk.TRUE)
    hbox.show_all()
    return (hbox, label, entry)

def make_buttons(list):
    buttonbox = gtk.HBox()
    for label, func in list:
        button = gtk.Button()
        button.set_label(label)
        button.connect("clicked", func)
        button.show()
        buttonbox.pack_start(button, expand=gtk.FALSE, fill=gtk.FALSE)
    buttonbox.show()
    return buttonbox

def printToBuffer(buffer, s):
    buffer.delete(buffer.get_start_iter(), buffer.get_end_iter())
    buffer.insert_at_cursor(s)

def repaint():
     while gtk.events_pending():
       gtk.mainiteration(gtk.FALSE)

# end of util functions

class managerWindow:
                                                                                                              
 def quit(*args):
    gtk.main_quit()
                                                                                                              
 def update_button(self, *args):
    self.process = "update"
    pkgaction.updatepkgs(self.tsInfo, self.HeaderInfo, self.rpmDBInfo, self.nulist, self.uplist, self.updateItems.keys(), 0)
    out = self.finalizeChanges()
    self.populateUpdateList(self.searchBox.get_text())
    if out != 0:
	updateItems = {}

 def install_button(self, *args):
    self.process = "install"
    pkgaction.installpkgs(self.tsInfo, self.nulist, self.installItems.keys(), self.HeaderInfo, self.rpmDBInfo, 0)
    out = self.finalizeChanges()
    self.populateUpdateList(self.searchBox.get_text())
    if out != 0:
	installItems = {}

 def remove_button(self, *args):
    self.process = "erase"
    pkgaction.erasepkgs(self.tsInfo, self.rpmDBInfo, self.removeItems.keys(), 0)
    out = self.finalizeChanges()
    self.populateUpdateList(self.searchBox.get_text())
    if out != 0:
	removeItems = {}
 
 def install_clicked(self, cell, path, model):
	self.item_clicked(cell, path, model, self.installItems, "install")
 def update_clicked(self, cell, path, model):
	self.item_clicked(cell, path, model, self.updateItems, "update")
 def remove_clicked(self, cell, path, model):
	self.item_clicked(cell, path, model, self.removeItems, "remove")
 def item_clicked(self,cell, path, model, itemsList, type):
    # get toggled iter
    iter = model.get_iter((int(path),))
    fixed = model.get_value(iter, 0)
                                                                                                              
    # do something with the value
    fixed = not fixed
                                                                                                              
    # set new value
    model.set(iter, 0, fixed)
    out = model.get_value(iter, 1)
    if fixed:
            itemsList[out] = fixed
    else:
            if itemsList.has_key(out):
                del itemsList[out]
 
 def populatePropertySheet(self, view, model):
    selection = view.get_selection()
    select_tuple = selection.get_selected()
    if select_tuple:
       	store, iter = select_tuple
	desc = store.get_value(iter, 4)
	#have to remove new lines due to formating in the text block
	desc = desc.replace('\n', ' ')
    	self.packageName.set_text(store.get_value(iter,1))
	printToBuffer(self.packageDescription, desc.strip())

 def make_view(self,model, flagColumn, toggleFunc):
    # Create the view itself.
    view = gtk.TreeView(model)
    view.connect('cursor-changed', self.populatePropertySheet,  model)
    renderer = gtk.CellRendererText()
                                                                                                                            
    renderer2 = gtk.CellRendererToggle()
    renderer2.connect('toggled', toggleFunc, model)
    column3 = gtk.TreeViewColumn(flagColumn, renderer2, active=0)
    column3.set_clickable(gtk.TRUE)
                                                                                                                            
    # set this column to a fixed sizing(of 50 pixels)
    column3.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
    column3.set_fixed_width(50)
    column3.set_clickable(gtk.FALSE)
    view.append_column(column3)
                                                                                                                            
    column = gtk.TreeViewColumn("Package", renderer, text=1)
    view.append_column(column)
    column2 = gtk.TreeViewColumn("Version", renderer, text=2)
    view.append_column(column2)
    column3 = gtk.TreeViewColumn("Arch", renderer, text=3)
    view.append_column(column3)
    view.show()
                                                                                                                            
    # Create scrollbars around the view.
    scrolled = gtk.ScrolledWindow()
    scrolled.add(view)
    scrolled.show()
                                                                                                                            
    return view, scrolled                                                                                                              
 # these functions depend on changes inside the config.py class.
 # these functions change params in the yumconf file and write the changes back to disc.
 # i guess these could be put in another class but since a parse is required it makes sense to me to put them in there

 # this function requires update_serverid.
 def edit_server_id(self, cell, path, newtext, model):
	iter = model.get_iter((int(path),))
	oldname = model.get_value(iter, 0)
	model.set_value(iter, 0, newtext)
	self.conf.update_serverid(oldname, newtext)
        self.conf=yumconf(configfile=self.yumconffile)
 # this function requires edit_server_baseurl.
 def edit_server_baseurl(self, cell, path, newtext, model):
	iter = model.get_iter((int(path),))
	serverid = model.get_value(iter, 0)
	model.set_value(iter, 2, newtext)
	self.conf.update_baseurl(serverid, newtext)
        self.conf=yumconf(configfile=self.yumconffile)
 # this function requires update_servername.
 def edit_server_name(self, cell, path, newtext, model):
	iter = model.get_iter((int(path),))
	serverid = model.get_value(iter, 0)
	model.set_value(iter, 1, newtext)
        self.conf=yumconf(configfile=self.yumconffile)
	self.conf.update_servername(serverid, newtext)
 # this function requires update_gpgcheck.
 def edit_server_gpg_check(self, cell, path, model):
	iter = model.get_iter((int(path),))
	val = not model.get_value(iter,3)
	model.set_value(iter, 3, val)
	serverid = model.get_value(iter, 0)
	self.conf.update_gpgcheck(serverid, val)
        self.conf=yumconf(configfile=self.yumconffile)
 # this function requires remove_server.
 def delete_server(self, *args):
	selection = self.ConfView.get_selection()
	select_tuple = selection.get_selected()
	if select_tuple:
		store, iter = select_tuple
		serverid = self.ConfModel.get_value(iter, 0)
		self.conf.remove_server(serverid)
		store.remove(iter)
        self.conf=yumconf(configfile=self.yumconffile)
 # this function requires add_server.
 def add_server(self, *args):
	serverid = "new_server"
	serverName = "New Server Name"
	serverUrl = "http://host/path"
	serverGpg = 0
	iter = self.ConfModel.insert_before(None, None)
        self.ConfModel.set_value(iter, 0, serverid)
        self.ConfModel.set_value(iter, 1, serverName)
        self.ConfModel.set_value(iter, 2, serverUrl)
        self.ConfModel.set_value(iter, 3, serverGpg)
        self.ConfModel.set_value(iter, 4, 1)
	self.conf.add_server(serverid, serverName, serverUrl, serverGpg)
        self.conf=yumconf(configfile=self.yumconffile)
 # END functions that require changes to config.py

 def update_headers(self, *args):
	self.populateUpdateList(self.searchBox.get_text())

 def make_conf_view(self, model):
    # Create the view itself.
    view = gtk.TreeView(model)
    serverId = gtk.CellRendererText()
    column0 = gtk.TreeViewColumn("Server", serverId, text=0, editable=4)
    serverId.connect('edited', self.edit_server_id, model)
    view.append_column(column0)
    serverName = gtk.CellRendererText()
    column1 = gtk.TreeViewColumn("Server Name", serverName, text=1, editable=4)
    serverName.connect('edited', self.edit_server_name, model)
    view.append_column(column1)
    checkGpg = gtk.CellRendererToggle()
    baseurl = gtk.CellRendererText()
    column2 = gtk.TreeViewColumn("Base Url", baseurl, text=2, editable=4)
    baseurl.connect('edited', self.edit_server_baseurl, model)
    view.append_column(column2)
    checkGpg = gtk.CellRendererToggle()
    checkGpg.connect('toggled', self.edit_server_gpg_check, model)
    column3 = gtk.TreeViewColumn("Check GPG", checkGpg, active=3)
    column3.set_clickable(gtk.TRUE)
    column3.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
    column3.set_fixed_width(100)
    column3.set_clickable(gtk.FALSE)
    view.append_column(column3)
    view.show()
    scrolled = gtk.ScrolledWindow()
    scrolled.add(view)
    scrolled.show()
    return view, scrolled
 
 def getStatusWindow(self):
    scrolled = gtk.ScrolledWindow()
    scrolled.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    scrolled.add(self.textview)
    self.textview.set_editable(gtk.FALSE)
    return scrolled
 def finalizeChanges(self):
    repaint()
    self.save_state()
    # if for some reason we've gotten all the way through this step with
    # an empty tsInfo then exit and be confused :)
    if len(self.tsInfo.NAkeys()) < 1:
        self.log(2, _('No actions to take'))
	return 0
    if self.process not in ('erase', 'remove'):
     	# put available pkgs in tsInfonevral in state 'a'
    	for (name, arch) in self.nulist:
            if not self.tsInfo.exists(name, arch):
                ((e, v, r, a, l, i), s)=self.HeaderInfo._get_data(name, arch)
                self.tsInfo.add((name, e, v, r, arch, l, i), 'a')
    self.log(2, _('Resolving dependencies'))
    (errorcode, msgs) = self.tsInfo.resolvedeps(self.rpmDBInfo)
    if errorcode:
        for msg in msgs:
            self.log(2,msg)
        return 0
    self.log(2, _('Dependencies resolved'))
    # prompt for use permission to do stuff in tsInfo - list all the actions
    # (i, u, e, ed, ud,iu(installing, but marking as 'u' in the actual ts, just
    # in case)) confirm w/the user
                                                                                                                            
    (self.i_list, self.u_list, self.e_list, self.ud_list, self.ed_list)=clientStuff.actionslists(self.tsInfo)

    self.dialog = gtk.Dialog("Proceed", self.win, 0, ("Continue", 1, "Cancel",0))
    self.dialogLabel = gtk.Label('I\'m going to do the following:')
    self.dialogLabel.set_justify(gtk.JUSTIFY_LEFT)
    self.dialogLabel.set_alignment(0,0)
    textview = gtk.TextView(buffer=None)
    output = textview.get_buffer()
    scrolled = gtk.ScrolledWindow()
    scrolled.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    scrolled.add(textview)
    self.dialog.vbox.pack_start(self.dialogLabel, expand=gtk.FALSE, fill=gtk.FALSE)
    self.dialog.vbox.pack_start(scrolled, expand=gtk.TRUE, fill=gtk.TRUE)
    self.dialog.show_all()
    self.dialog.resize(350,250)
    # Hacky.  Change the textview of the output stream to the textview buffer in the popup window
    #  then change it back.
    self.output.set_textview(textview)
    clientStuff.printactions(self.i_list, self.u_list, self.e_list, self.ud_list, self.ed_list, self.tsInfo)
    self.output.set_textview(self.textview)

    result = self.dialog.run()
    repaint()
    self.dialog.hide()
    self.dialog.destroy()
    if self.conf.assumeyes==0:
        if result == 0:
        	self.log(2, _('\n\nCanceled...\nNo Actions Taken\n\nUpdating Available Packages'))
		
		return 0

    # Test run for file conflicts and diskspace check, etc.
    # download first
    self.log(2, _('Downloading Packages'))
    clientStuff.download_packages(self.tsInfo)
    self.log(3, _('Creating Transaction Set'))
    self.tstest = self.tsInfo.populateTs(addavailable = 0, localrpm = 1)
    self.log(2, _('Running test transaction:'))
    clientStuff.tsTest(self.tstest)
    self.tstest.closeDB()
    del self.tstest
#    if self.tstest == -1:
#	self.log(2, "\n\nERROR OCCURED....\nNo Actions Taken")
#	return -1


    self.log(2, _('Test transaction complete, Success!'))

    # need to get the state of the install process and add to the progress bar!
    self.progressbarSmall.set_fraction(0)
    self.progressbarSmall.set_text("")
    repaint()
    self.log(2, _('Preparing to perform actions.'))
    # FIXME the actual run should probably be elsewhere and this should be
    # inside a try, except set
    self.tsfin = self.tsInfo.populateTs(addavailable = 0, localrpm = 1)
                                                                                                                            
    if self.conf.diskspacecheck == 0:
        self.tsfin.setProbFilter(rpm.RPMPROB_FILTER_DISKSPACE)

    if self.conf.uid == 0:
    	self.log(2, _('Performing Actions.'))
	repaint()
        # sigh - the magical "order" command - nice of this not to really be
        # documented anywhere.
        self.tsfin.check()
        self.tsfin.order()
        cb = callback.RPMInstallCallback()
        errors = self.tsfin.run(cb.callback, '')
        if errors:
            errorlog(0, _('Errors installing:'))
            for error in errors:
                errorlog(0, error)
            #sys.exit(1)
        self.tsfin.closeDB()
        del self.tsfin
        # Check to see if we've got a new kernel and put it in the right place in grub/lilo
        pkgaction.kernelupdate(self.tsInfo)
        # log what we did and also print it out
        clientStuff.filelogactions(self.i_list, self.u_list, self.e_list, self.ud_list, self.ed_list, self.tsInfo)
        clientStuff.shortlogactions(self.i_list, self.u_list, self.e_list, self.ud_list, self.ed_list, self.tsInfo)
    else:
        errorlog(1, _('You\'re not root, we can\'t install things'))

    repaint()
    self.log(2, _('Transaction(s) Complete'))
    repaint()
    self.load_new_state()
    return 1

 def save_state(self):
    if nautilus_desktop:
	self.menu = mmupdate.desktop_folder()
	self.menu.setCurrentState()

 def load_new_state(self):
    if nautilus_desktop:
	self.menu.setFinalState()
	self.menu.writeChanges(nautilus_desktop)
    	home = "/home"
	if os.access(home, os.F_OK):
		files = os.listdir("/home")
		for file in files:
		  fullpath = home + sep + file
		  if os.path.isdir(fullpath):
			self.menu.writeChanges(fullpath)
      
 def getYumData(self):
      (self.log, self.conf, self.nulist, self.uplist, self.newlist, self.obsoleting, \
         self.tsInfo, self.HeaderInfo, self.rpmDBInfo, self. obsoleted) = setupYum(self.output)
      self.progressbarSmall.set_text("0%")
      self.progressbarSmall.set_size_request(100,20)
      self.conf.progress_obj = progress_bar.gui_progress_bar(bar=self.progressbarSmall, status=self.statusbar)
      

 def populateUpdateList(self, search=None):
    repaint()

    self.getYumData()

    self.createViewOfData(search)
    self.log(2, product_name + " is ready...")
 def updateList(self, model, list, selectedList, headerInfo, scrollwin, noresultslbl, search=None, tabLabel=None, tabValue=""):
    model.clear()
                                                                                                                            
    Len = 0
    list.sort(clientStuff.nasort)
    self.log(2, "Searching %s(s)" % tabValue)
    if len(list) > 0:
        for (name, arch) in list:
              (e,v,r) = headerInfo.evr(name,arch)
              id = headerInfo.serverid(name, arch)
	      hdr = headerInfo.getHeader(name, arch)
              if e == '0':
                 ver = '%s-%s' % (v, r)
              else:
                 ver = '%s:%s-%s' % (e, v, r)
	      self.progressbarSmall.pulse()
	      repaint()
              if self.searchMatch(name, hdr["description"], search):
                 iter = model.insert_before(None, None)
                 if selectedList.has_key(name):
                        model.set_value(iter, 0, 1)
                 else:
                        model.set_value(iter, 0, 0)
                 model.set_value(iter, 1, name)
                 model.set_value(iter, 2, ver)
		 model.set_value(iter, 3, arch)
		 model.set_value(iter, 4, hdr["description"])
                 Len = Len + 1
                                                                                                                            
    if Len == 0:
        scrollwin.hide()
        noresultslbl.show()
    else:
        scrollwin.show()
        noresultslbl.hide()
    if tabLabel:
	tabLabel.set_text(tabValue + " (%i)" % Len)

    self.progressbarSmall.set_fraction(0)
    self.progressbarSmall.set_text("")


 def createViewOfData(self, search=None):
    self.updateList(self.model, self.uplist, self.updateItems, self.HeaderInfo, self.UpdateScrolled, self.UpdateNoResults, search, self.updateLabel_tab, "Update")
		
    self.updateList(self.InstallModel, self.newlist, self.installItems, self.HeaderInfo, self.InstallScrolled, self.InstallNoResults, search, self.installLabel_tab, "Install")

    self.updateList(self.RemoveModel, self.rpmDBInfo.NAkeys(), self.removeItems, self.rpmDBInfo, self.RemoveScrolled, self.RemoveNoResults, search, self.removeLabel_tab, "Remove")

    self.ConfModel.clear()
    for serverid in self.conf.servers:
        iter = self.ConfModel.insert_before(None, None)
	self.ConfModel.set_value(iter, 0, serverid)
	self.ConfModel.set_value(iter, 1, self.conf.servername[serverid])
	self.ConfModel.set_value(iter, 2, self.conf.serverurl[serverid][0])
	self.ConfModel.set_value(iter, 3, self.conf.servergpgcheck[serverid])
	self.ConfModel.set_value(iter, 4, 1)
 
 def searchMatch(self, name, desc, search):
     if search:
	search = search.lower()
     else:
	return 1
     if name:
     	name = name.lower()
     if desc:
     	desc = desc.lower()
     return ( search == None or len(search.strip()) == 0 or name.find(search) >= 0 or desc.find(search) >= 0)
	
 def __init__(self):
    self.yumconffile='/etc/yum.conf'
    self.updateItems = {}
    self.installItems = {}
    self.removeItems = {}
    # Create the model.
    self.model = gtk.TreeStore( gobject.TYPE_BOOLEAN, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)

    # Create the model.
    self.InstallModel = gtk.TreeStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
                                                                            
    self.RemoveModel = gtk.TreeStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
    self.ConfModel = gtk.TreeStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_BOOLEAN, gobject.TYPE_BOOLEAN)

 def createBootSplash(self):
    self.splashWindow = gtk.Window()
    self.splashWindow.set_position(gtk.WIN_POS_CENTER)
    self.splashWindow.connect("delete_event", self.quit)
    self.splashWindow.set_title(product_name)
    vbox = gtk.VBox()
    if os.path.exists(product_icon_file):
	icon = gtk.gdk.pixbuf_new_from_file(product_icon_file)
	self.splashWindow.set_icon(icon)
    sharePath = '/usr/share/yum'
    if os.path.exists(sharePath + sep + product_image_file):
    	image = gtk.Image()
    	image.set_from_file(sharePath + sep + product_image_file)
    elif os.path.exists(product_image_file):
    	image = gtk.Image()
	image.set_from_file(product_image_file)
    else:
	image = gtk.Label(product_name)
    vbox.add(image)
    self.splashWindow.set_modal(gtk.TRUE)
    self.splashWindow.set_decorated(gtk.TRUE)
    self.splashWindow.resize(300, 200)
    self.splashWindow.add(vbox)
    self.splashWindow.show_all()

 def createPropertySheet(self):
    vbox = gtk.VBox()
    (name, label, self.packageName) = createTextBox("Package Name")
    (desc, label, self.packageDescription) = createScrollText("Description")
    vbox.pack_start(name, expand=gtk.TRUE, fill=gtk.FALSE)
    vbox.pack_start(desc, expand=gtk.TRUE, fill=gtk.TRUE)
    return vbox

 def initData(self, *args):
	self.getYumData()
	self.log(2, "Populating Data")
	self.createViewOfData()
	self.splashWindow.hide()
	self.splashWindow.destroy()
        self.log(2, product_name + " is ready...")

 def search(self, *args):
	self.updateItems = {}
	self.installItems = {} 
    	self.removeItems = {}
	self.createViewOfData(self.searchBox.get_text())

 def createMainWindow(self):
    # Create the main view.
    global view
    self.UpdateView, self.UpdateScrolled = self.make_view(self.model,"Update", self.update_clicked)
                                                                                                                            
    # Create some command buttons.
    self.UpdateButtons = make_buttons([("Update", self.update_button)])
                                                                                                                            
    self.searchBox = gtk.Entry()
    self.searchBox.connect("activate", self.search)
    searchButton = gtk.Button()
    searchButton.set_label("Search")
    searchButton.connect("clicked", self.search)
    search = gtk.HBox()
    search.pack_start(self.searchBox)
    search.pack_start(searchButton)
    search.show_all()
    self.UpdateNoResults = gtk.Label("No Results")
    # Create a vertical box to hold the above stuff.
    vbox = gtk.VBox()
    vbox.pack_start(self.UpdateScrolled, expand=gtk.TRUE, fill=gtk.TRUE)
    vbox.pack_start(self.UpdateNoResults, expand=gtk.TRUE, fill=gtk.TRUE)
    vbox.pack_start(self.UpdateButtons, expand=gtk.FALSE, fill=gtk.FALSE)
    vbox.show()
                                                                                                                            
    self.InstallView, self.InstallScrolled = self.make_view(self.InstallModel, "Install", self.install_clicked)
    self.InstallButtons = make_buttons([("Install", self.install_button)])
    self.InstallNoResults = gtk.Label("No Results")
    install = gtk.VBox()
    install.pack_start(self.InstallScrolled, expand=gtk.TRUE, fill=gtk.TRUE)
    install.pack_start(self.InstallNoResults, expand=gtk.TRUE, fill=gtk.TRUE)
    install.pack_start(self.InstallButtons, expand=gtk.FALSE, fill=gtk.FALSE)
    install.show()

    self.RemoveView, self.RemoveScrolled = self.make_view(self.RemoveModel, "Remove", self.remove_clicked)
    self.RemoveButtons = make_buttons([("Remove", self.remove_button)])
    self.RemoveNoResults = gtk.Label("No Results")
    remove = gtk.VBox()
    remove.pack_start(self.RemoveScrolled, expand=gtk.TRUE, fill=gtk.TRUE)
    remove.pack_start(self.RemoveNoResults, expand=gtk.TRUE, fill=gtk.TRUE)
    remove.pack_start(self.RemoveButtons, expand=gtk.FALSE, fill=gtk.FALSE)
    remove.show()

    self.ConfView, self.ConfScrolled = self.make_conf_view(self.ConfModel)
    self.ConfButtons = make_buttons([("Add", self.add_server), ("Remove", self.delete_server), ("Update Headers", self.update_headers)])
    conf = gtk.VBox()
    conf.pack_start(self.ConfScrolled, expand=gtk.TRUE, fill=gtk.TRUE)
    conf.pack_start(self.ConfButtons, expand=gtk.FALSE, fill=gtk.FALSE)
    conf.show()


    # Create toplevel window to show it all.
    self.win = gtk.Window(gtk.WINDOW_TOPLEVEL)
    self.win.set_position(gtk.WIN_POS_CENTER)
    self.win.set_title(product_name)
    self.win.connect("delete_event", self.quit)
    bottomHbox = gtk.HPaned()
    propertyLabel = self.createPropertySheet()
    propertyLabel.set_size_request(10,10) 
    self.statusWindow = self.getStatusWindow()
    self.statusWindow.set_size_request(10,10)
    bottomHbox.pack1(propertyLabel, resize=gtk.TRUE, shrink=gtk.TRUE)
    bottomHbox.pack2(self.statusWindow, resize=gtk.TRUE, shrink=gtk.TRUE) 
    bottomHbox.set_size_request(20,10)
    bottomHbox.show_all()

    notebook = gtk.Notebook()
    notebook.set_tab_pos(gtk.POS_TOP)
    topVbox = gtk.VPaned()
    topHalf = gtk.VBox()
    topHalf.pack_start(search, expand=gtk.FALSE, fill=gtk.FALSE)
    topHalf.pack_start(notebook, expand=gtk.TRUE, fill=gtk.TRUE)
    
    topHalf.set_size_request(20,50)

    bottomHalf = gtk.VBox()

    bottomHalf.pack_start(bottomHbox, expand=gtk.TRUE, fill=gtk.TRUE)
    frame1 = gtk.Frame()
    frame1.add(topHalf)
    frame1.set_shadow_type(gtk.SHADOW_IN)
    topVbox.pack1(frame1, resize=gtk.TRUE, shrink=gtk.TRUE)
    frame2 = gtk.Frame()
    frame2.add(bottomHalf)
    frame2.set_shadow_type(gtk.SHADOW_IN)
    topVbox.pack2(frame2, resize=gtk.TRUE, shrink=gtk.TRUE)

    self.progressbarSmall = gtk.ProgressBar()
    self.statusbar.set_size_request(100,20)
    statusBarHbox = gtk.HBox(spacing=5)
    statusBarHbox.pack_start(self.progressbarSmall, expand=gtk.FALSE, fill=gtk.FALSE)
    statusBarHbox.pack_start(self.statusbar, expand=gtk.TRUE, fill=gtk.TRUE)
    bottomHalf.pack_start(statusBarHbox, expand=gtk.FALSE, fill=gtk.FALSE)
    self.win.add(topVbox)
    topVbox.show_all()
    self.installLabel_tab = gtk.Label("Install")
    notebook.append_page(install,self.installLabel_tab)
    self.removeLabel_tab = gtk.Label("Remove")
    notebook.append_page(remove, self.removeLabel_tab)
    self.updateLabel_tab = gtk.Label("Update")
    notebook.append_page(vbox, self.updateLabel_tab)
    confLabel = gtk.Label("Settings")

    # Because the settings tab requires the addition of functions to the config.py file 
    # I check to see if that
    try:
         if yumconf.update_serverid:
	    notebook.append_page(conf, confLabel)
    except:
	print "Could not setup settings tab.  Config.py needs mods."

    notebook.show()
    if os.path.exists(product_icon_file):
        icon = gtk.gdk.pixbuf_new_from_file(product_icon_file)
        self.win.set_icon(icon)
    self.win.set_default_size(500, 400)
    self.win.show()

 def main(self):
    self.statusbar = gtk.Statusbar()
    self.textview = gtk.TextView(buffer=None)
    self.output = textviewStream(self.textview, self.statusbar)
    # paint the windows then initililize the data from yum.  This sets up the package lists
    # 5 second delay to account for older machines that take a while to paint
    as = gtk.timeout_add(5000,self.initData)
    self.createMainWindow()
    self.createBootSplash()
    # Run the Gtk+ main loop.
    gtk.main()

# Taken from yummain.py.  This will have to updated as the versions change.
# I envision this type of function being inside yummain.py so it can just be called from here.
def parseCmdArgs(textB=None):
    # setup our errorlog object 

    if textB:
    	errorlog=Logger(threshold=2, file_object=textB)
    else:
    	errorlog=Logger(threshold=2, file_object=sys.stderr)
	

    # our default config file location
    yumconffile=None
    if os.access("/etc/yum.conf", os.R_OK):
        yumconffile="/etc/yum.conf"
        
        if yumconffile:
            conf=yumconf(configfile=yumconffile)
        else:
            errorlog(0, _('Cannot find any conf file.'))
            sys.exit(1)
        # who are we:
        conf.uid=os.geteuid()
        # version of yum
        conf.yumversion = __version__
        # we'd like to have a log object now
	if textB:
	        log=Logger(threshold=conf.debuglevel, file_object=textB)
	else:	
	        log=Logger(threshold=conf.debuglevel, file_object=sys.stdout)
        # syslog-style log
        if conf.uid == 0:
            logfile=open(conf.logfile,"a")
            filelog=Logger(threshold=10, file_object=logfile,preprefix=clientStuff.printtime())
        else:
            filelog=Logger(threshold=10, file_object=None,preprefix=clientStuff.printtime())

    cmds = None 
    return (log, errorlog, filelog, conf, cmds)


# Taken from yummain.py.  This will have to updated as the versions change.
# I envision this type of function being inside yummain.py so it can just be called from here.
def setupYum(textB=None):
    """This does all the real work"""

    locale.setlocale(locale.LC_ALL, '')
    
    (log, errorlog, filelog, conf, cmds) = parseCmdArgs(textB)
    
    # some misc speedups/sanity checks
    if conf.uid != 0:
        conf.cache=1

    #if process == 'clean':
    #    conf.cache=1
        
    # push the logs into the other namespaces
    pkgaction.log = log
    clientStuff.log = log
    nevral.log = log
    rpmUtils.log = log

    pkgaction.errorlog = errorlog
    clientStuff.errorlog = errorlog
    nevral.errorlog = errorlog
    rpmUtils.errorlog = errorlog
    
    pkgaction.filelog = filelog
    clientStuff.filelog = filelog
    nevral.filelog = filelog
    rpmUtils.filelog = filelog
    
    # push the conf file into the other namespaces
    nevral.conf = conf
    clientStuff.conf = conf
    pkgaction.conf = conf
    callback.conf = conf
    rpmUtils.conf = conf
    
    # get our ts together that we'll use all over the place
    ts = rpmUtils.Rpm_Ts_Work()
    ts.sigChecking('none')
    clientStuff.ts = ts
    pkgaction.ts = ts
    nevral.ts = ts
    rpmUtils.ts = ts
    yumcomps.ts = ts
    
    # make remote nevral class
    HeaderInfo = nevral.nevral()
    
    # sorting the servers so that sort() will order them consistently
    # If you wanted to add scoring or somesuch thing for server preferences
    # or even getting rid of servers b/c of some criteria you could
    # replace serverlist.sort() with a function - all it has to do
    # is return an ordered list of serverids and have it stored in
    # serverlist
    serverlist = conf.servers
    serverlist.sort()

    # get the package info file
    clientStuff.get_package_info_from_servers(serverlist, HeaderInfo)
    
    # make local nevral class
    rpmDBInfo = nevral.nevral()
    clientStuff.rpmdbNevralLoad(rpmDBInfo)

    # create transaction set nevral class
    tsInfo = nevral.nevral()
    #################################################################################
    # generate all the lists we'll need to quickly iterate through the lists.
    #  uplist == list of updated packages
    #  newlist == list of uninstall/available NEW packages (ones we don't have at all)
    #  nulist == combination of the two
    #  obslist == packages obsoleting a package we have installed
    ################################################################################
    log(2, _('Finding updated packages'))
    (uplist, newlist, nulist) = clientStuff.getupdatedhdrlist(HeaderInfo, rpmDBInfo)
    
    #if process != 'clean':
    #    log(2, _('Downloading needed headers'))
    clientStuff.download_headers(HeaderInfo, nulist)

    # once we've gone through and found out which headers we know about
    # generate the lists again so there is no confusion about what is available
    (uplist, newlist, nulist) = clientStuff.getupdatedhdrlist(HeaderInfo, rpmDBInfo)
    
#    if process in ['upgrade', 'groupupgrade']:
    log(2, _('Finding obsoleted packages'))
    obsoleting, obsoleted = clientStuff.returnObsoletes(HeaderInfo, rpmDBInfo, nulist)
#    else:
#        obsoleting = {}
#        obsoleted = {}

    
    log(3, 'nulist = %s' % len(nulist))
    log(3, 'uplist = %s' % len(uplist))
    log(3, 'newlist = %s' % len(newlist))
    log(3, 'obsoleting = %s' % len(obsoleting.keys()))
    log(3, 'obsoleted = %s' % len(obsoleted.keys()))

    
    ##################################################################
    # at this point we have all the prereq info we could ask for. we 
    # know whats in the rpmdb whats available, whats updated and what 
    # obsoletes. We should be able to do everything we want from here 
    # w/o getting anymore header info
    ##################################################################

    return (log, conf, nulist, uplist, newlist, obsoleting, tsInfo, HeaderInfo, rpmDBInfo, obsoleted) 

def usage():
    sys.exit(1)

# Need to add command line params for things like redirecting yumconf
if __name__ == "__main__":
    mainwin = managerWindow()
    mainwin.main()
